searchNodes=[{"doc":"The rate at which a video file frames are played back. Framerate is measured in frames-per-second (24/1 = 24 frames-per-second).","ref":"Vtc.Framerate.html","title":"Vtc.Framerate","type":"module"},{"doc":"Creates a new Framerate with a playback speed or timebase. Arguments rate : Either the playback rate or timebase. For NTSC framerates, the value will be rounded to the nearest correct value. ntsc : Atom representing the which (or whether an) NTSC standard is being used. coerce_seconds_per_frame? : If true , then values such as 1/24 are assumed to be in seconds-per-frame format and automatically converted to 24/1 . Useful when you want to convert strings from multiple sources when some are seconds-per-frame and others are frames-per-second. NOTE: if you expect to be dealing with record-rate values for timelapse use at your own risk! NOTE: Floats cannot be passed if the rate is not NTSC and the value is not a while number, as there is no way to know the precise time do to floating-point errors.","ref":"Vtc.Framerate.html#new/3","title":"Vtc.Framerate.new/3","type":"function"},{"doc":"As new/2 but raises an error instead.","ref":"Vtc.Framerate.html#new!/3","title":"Vtc.Framerate.new!/3","type":"function"},{"doc":"Returns true if the value represents and NTSC framerate, therefore will return true on a Framerate with an :ntsc value of :non_drop and :drop .","ref":"Vtc.Framerate.html#ntsc?/1","title":"Vtc.Framerate.ntsc?/1","type":"function"},{"doc":"The rational representation of the timecode timebase speed as a fraction in frames-per-second.","ref":"Vtc.Framerate.html#timebase/1","title":"Vtc.Framerate.timebase/1","type":"function"},{"doc":"Example returns: 23.98 NTSC DF 23.98 NTSC NDF 23.98 fps","ref":"Vtc.Framerate.html#to_string/1","title":"Vtc.Framerate.to_string/1","type":"function"},{"doc":"Enum of Ntsc types. Values nil : Not an NTSC value :non_drop A non-drop NTSC value. :drop A drop-frame ntsc value. For more information on NTSC standards and framerate conventions, see Frame.io's blogpost on the subject.","ref":"Vtc.Framerate.html#t:ntsc/0","title":"Vtc.Framerate.ntsc/0","type":"type"},{"doc":"Type returned by new/2","ref":"Vtc.Framerate.html#t:parse_result/0","title":"Vtc.Framerate.parse_result/0","type":"type"},{"doc":"Type of Framerate Fields playback : The rational representation of the real-world playback speed as a fraction in frames-per-second. ntsc : Atom representing which, if any, NTSC convention this framerate adheres to.","ref":"Vtc.Framerate.html#t:t/0","title":"Vtc.Framerate.t/0","type":"type"},{"doc":"Pre-defined framerates commonly used in the wild.","ref":"Vtc.Rates.html","title":"Vtc.Rates","type":"module"},{"doc":"23.98 NTSC Non-drop","ref":"Vtc.Rates.html#f23_98/0","title":"Vtc.Rates.f23_98/0","type":"function"},{"doc":"24 fps","ref":"Vtc.Rates.html#f24/0","title":"Vtc.Rates.f24/0","type":"function"},{"doc":"29.97 NTSC Drop-frame","ref":"Vtc.Rates.html#f29_97_df/0","title":"Vtc.Rates.f29_97_df/0","type":"function"},{"doc":"29.97 NTSC Non-drop","ref":"Vtc.Rates.html#f29_97_ndf/0","title":"Vtc.Rates.f29_97_ndf/0","type":"function"},{"doc":"30 fps","ref":"Vtc.Rates.html#f30/0","title":"Vtc.Rates.f30/0","type":"function"},{"doc":"47.95 NTSC Non-drop","ref":"Vtc.Rates.html#f47_95/0","title":"Vtc.Rates.f47_95/0","type":"function"},{"doc":"48 fps","ref":"Vtc.Rates.html#f48/0","title":"Vtc.Rates.f48/0","type":"function"},{"doc":"59.94 NTSC Drop-frame","ref":"Vtc.Rates.html#f59_94_df/0","title":"Vtc.Rates.f59_94_df/0","type":"function"},{"doc":"59.94 NTSC Non-drop","ref":"Vtc.Rates.html#f59_94_ndf/0","title":"Vtc.Rates.f59_94_ndf/0","type":"function"},{"doc":"60 fps","ref":"Vtc.Rates.html#f60/0","title":"Vtc.Rates.f60/0","type":"function"},{"doc":"Protocols for source values that can be used to construct a timecode.","ref":"Vtc.Source.html","title":"Vtc.Source","type":"module"},{"doc":"Protocol which types can implement to be passed as the main value of Timecode.with_frames/2 . Implementations Out of the box, this protocol is implemented for the following types: Integer String &amp; 'BitString' timecode (&quot;01:00:00:00&quot;) integer (&quot;86400&quot;) Feet+Frames (&quot;5400+00&quot;)","ref":"Vtc.Source.Frames.html","title":"Vtc.Source.Frames","type":"protocol"},{"doc":"Returns the value as a frame count. Arguments value : The source value. rate : The framerate of the timecode being parsed. Returns A result tuple with an integer value representing the frame count on success.","ref":"Vtc.Source.Frames.html#frames/2","title":"Vtc.Source.Frames.frames/2","type":"function"},{"doc":"Result type of Vtc.Source.Frames.frames/2 aaa .","ref":"Vtc.Source.Frames.html#t:result/0","title":"Vtc.Source.Frames.result/0","type":"type"},{"doc":"","ref":"Vtc.Source.Frames.html#t:t/0","title":"Vtc.Source.Frames.t/0","type":"type"},{"doc":"Protocol which types can implement to be passed as the main value of Vtc.Timecode.with_premiere_ticks/2 . Implementations Out of the box, this protocol is implemented for the following types: Integer","ref":"Vtc.Source.PremiereTicks.html","title":"Vtc.Source.PremiereTicks","type":"protocol"},{"doc":"Returns the number of Adobe Premiere Pro ticks as an integer. Arguments value : The source value. rate : The framerate of the timecode being parsed. Returns A result tuple with a rational representation of the seconds value using Ratio on success.","ref":"Vtc.Source.PremiereTicks.html#ticks/2","title":"Vtc.Source.PremiereTicks.ticks/2","type":"function"},{"doc":"Result type of ticks/2 .","ref":"Vtc.Source.PremiereTicks.html#t:result/0","title":"Vtc.Source.PremiereTicks.result/0","type":"type"},{"doc":"","ref":"Vtc.Source.PremiereTicks.html#t:t/0","title":"Vtc.Source.PremiereTicks.t/0","type":"type"},{"doc":"Protocol which types can implement to be passed as the main value of Timecode.with_seconds/2 . Implementations Out of the box, this protocol is implemented for the following types: Ratio Integer Float String runtime (&quot;01:00:00.0&quot;) decimal (&quot;3600.0&quot;)","ref":"Vtc.Source.Seconds.html","title":"Vtc.Source.Seconds","type":"protocol"},{"doc":"Returns the value as a rational seconds value. Arguments value : The source value. rate : The framerate of the timecode being parsed. Returns A result tuple with a rational representation of the seconds value using Ratio on success.","ref":"Vtc.Source.Seconds.html#seconds/2","title":"Vtc.Source.Seconds.seconds/2","type":"function"},{"doc":"Result type of Source.Seconds.seconds/2 .","ref":"Vtc.Source.Seconds.html#t:result/0","title":"Vtc.Source.Seconds.result/0","type":"type"},{"doc":"","ref":"Vtc.Source.Seconds.html#t:t/0","title":"Vtc.Source.Seconds.t/0","type":"type"},{"doc":"Represents the frame at a particular time in a video. New Timecode values are created with the with_seconds/2 and with_frames/2 , and other function prefaced by with_* .","ref":"Vtc.Timecode.html","title":"Vtc.Timecode","type":"module"},{"doc":"Adds two timecodoes together using their real-world seconds representation. When the rates of a and b are not equal, the result will inheret the framerat of a and be rounded to the seconds representation of the nearest whole-frame at that rate. b May be any value that implements the Frames protocol, such as a timecode string, and will be assumed to be the same framerate as a . This is mostly to support quick scripting. This function will raise if there is an error parsing b . Examples Two timecodes running at the same rate: iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;01:30:21:17&quot; , Rates . f23_98 ( ) ) iex&gt; Timecode . add ( a , b ) |&gt; Timecode . to_string ( ) &quot;&lt;02:30:21:17 @ &lt;23.98 NTSC NDF&gt;&gt;&quot; Two timecodes running at different rates: iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;00:00:00:02&quot; , Rates . f47_95 ( ) ) iex&gt; Timecode . add ( a , b ) |&gt; Timecode . to_string ( ) &quot;&lt;01:00:00:01 @ &lt;23.98 NTSC NDF&gt;&gt;&quot; Using a timcode and a bare string: iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; Timecode . add ( a , &quot;01:30:21:17&quot; ) |&gt; Timecode . to_string ( ) &quot;&lt;02:30:21:17 @ &lt;23.98 NTSC NDF&gt;&gt;&quot;","ref":"Vtc.Timecode.html#add/2","title":"Vtc.Timecode.add/2","type":"function"},{"doc":"Returns whether a is greater than, equal to, or less than b in terms of real-world seconds. b May be any value that implements the Frames protocol, such as a timecode string, and will be assumed to be the same framerate as a . This is mostly to support quick scripting. This function will raise if there is an error parsing b . Examples Using two timecodes, 01:00:00:00 NTSC is greater than 01:00:00:00 true because it represents more real-world time. iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f24 ( ) ) iex&gt; :gt = Timecode . compare ( a , b ) Using a timcode and a bare string: iex&gt; timecode = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; :eq = Timecode . compare ( timecode , &quot;01:00:00:00&quot; )","ref":"Vtc.Timecode.html#compare/2","title":"Vtc.Timecode.compare/2","type":"function"},{"doc":"Divides a by b . The result will inheret the framerat of a and be rounded to the seconds representation of the nearest whole-frame at that rate. Examples iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; Timecode . div ( a , 2 ) |&gt; Timecode . to_string ( ) &quot;&lt;00:30:00:00 @ &lt;23.98 NTSC NDF&gt;&gt;&quot; iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; Timecode . div ( a , 0.5 ) |&gt; Timecode . to_string ( ) &quot;&lt;02:00:00:00 @ &lt;23.98 NTSC NDF&gt;&gt;&quot;","ref":"Vtc.Timecode.html#div/2","title":"Vtc.Timecode.div/2","type":"function"},{"doc":"Returns the number of feet and frames this timecode represents if it were shot on 35mm 4-perf film (16 frames per foot). ex: '5400+13'. What it is On physical film, each foot contains a certain number of frames. For 35mm, 4-perf film (the most common type on Hollywood movies), this number is 16 frames per foot. Feet-And-Frames was often used in place of Keycode to quickly reference a frame in the edit. Where you see it For the most part, feet + frames has died out as a reference, because digital media is not measured in feet. The most common place it is still used is Studio Sound Departments. Many Sound Mixers and Designers intuitively think in feet + frames, and it is often burned into the reference picture for them. Telecine. Sound turnover reference picture. Sound turnover change lists.","ref":"Vtc.Timecode.html#feet_and_frames/1","title":"Vtc.Timecode.feet_and_frames/1","type":"function"},{"doc":"Returns the number of frames that would have elapsed between 00:00:00:00 and this timecode. What it is Frame number / frames count is the number of a frame if the timecode started at 00:00:00:00 and had been running until the current value. A timecode of '00:00:00:10' has a frame number of 10. A timecode of '01:00:00:00' has a frame number of 86400. Where you see it Frame-sequence files: 'my_vfx_shot.0086400.exr' FCP7XML cut lists: &lt;timecode&gt; &lt;rate&gt; &lt;timebase&gt;24&lt;/timebase&gt; &lt;ntsc&gt;TRUE&lt;/ntsc&gt; &lt;/rate&gt; &lt;string&gt;01:00:00:00&lt;/string&gt; &lt;frame&gt;86400&lt;/frame&gt; &lt;!-- &lt;====THIS LINE--&gt; &lt;displayformat&gt;NDF&lt;/displayformat&gt; &lt;/timecode&gt;","ref":"Vtc.Timecode.html#frames/1","title":"Vtc.Timecode.frames/1","type":"function"},{"doc":"Scales a by b . The result will inheret the framerat of a and be rounded to the seconds representation of the nearest whole-frame at that rate. Examples iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; Timecode . mult ( a , 2 ) |&gt; Timecode . to_string ( ) &quot;&lt;02:00:00:00 @ &lt;23.98 NTSC NDF&gt;&gt;&quot; iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; Timecode . mult ( a , 0.5 ) |&gt; Timecode . to_string ( ) &quot;&lt;00:30:00:00 @ &lt;23.98 NTSC NDF&gt;&gt;&quot;","ref":"Vtc.Timecode.html#mult/2","title":"Vtc.Timecode.mult/2","type":"function"},{"doc":"Returns the number of elapsed ticks this timecode represents in Adobe Premiere Pro. What it is Internally, Adobe Premiere Pro uses ticks to divide up a second, and keep track of how far into that second we are. There are 254016000000 ticks in a second, regardless of framerate in Premiere. Where you see it Premiere Pro Panel functions and scripts. FCP7XML cutlists generated from Premiere: &lt;clipitem id=&quot;clipitem-1&quot;&gt; ... &lt;in&gt;158&lt;/in&gt; &lt;out&gt;1102&lt;/out&gt; &lt;pproTicksIn&gt;1673944272000&lt;/pproTicksIn&gt; &lt;pproTicksOut&gt;11675231568000&lt;/pproTicksOut&gt; ... &lt;/clipitem&gt;","ref":"Vtc.Timecode.html#premiere_ticks/1","title":"Vtc.Timecode.premiere_ticks/1","type":"function"},{"doc":"Rebases the timecode to a new framerate. The real-world seconds are recalculated using the same frame count as if they were being played back at new_rate instead of timecode.rate . Examples iex&gt; timecode = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; { :ok , rebased } = Timecode . rebase ( timecode , Rates . f47_95 ( ) ) iex&gt; Timecode . to_string ( rebased ) &quot;&lt;00:30:00:00 @ &lt;47.95 NTSC NDF&gt;&gt;&quot;","ref":"Vtc.Timecode.html#rebase/2","title":"Vtc.Timecode.rebase/2","type":"function"},{"doc":"As rebase/2 , but raises on error.","ref":"Vtc.Timecode.html#rebase!/2","title":"Vtc.Timecode.rebase!/2","type":"function"},{"doc":"Runtime Returns the true, real-world runtime of the timecode in HH:MM:SS.FFFFFFFFF format. Arguments precision : The number of places to round to. Extra trailing 0's will still be trimmed. What it is The formatted version of seconds. It looks like timecode, but with a decimal seconds value instead of a frame number place. Where you see it • Anywhere real-world time is used. • FFMPEG commands: ffmpeg -ss 00:00:30.5 -i input.mov -t 00:00:10.25 output.mp4 Note The true runtime will often diverge from the hours, minutes, and seconds value of the timecode representation when dealing with non-whole-frame framerates. Even drop-frame timecode does not continuously adhere 1:1 to the actual runtime. For instance, &lt;01:00:00;00 @ &lt;29.97 NTSC DF&gt;&gt; has a true runtime of '00:59:59.9964', and &lt;01:00:00:00 @ &lt;23.98 NTSC NDF&gt;&gt; has a true runtime of '01:00:03.6'","ref":"Vtc.Timecode.html#runtime/2","title":"Vtc.Timecode.runtime/2","type":"function"},{"doc":"The individual sections of a timecode string as i64 values.","ref":"Vtc.Timecode.html#sections/1","title":"Vtc.Timecode.sections/1","type":"function"},{"doc":"Subtracts two timecodoes together using their real-world seconds representation. When the rates of a and b are not equal, the result will inheret the framerat of a and be rounded to the seconds representation of the nearest whole-frame at that rate. b May be any value that implements the Frames protocol, such as a timecode string, and will be assumed to be the same framerate as a . This is mostly to support quick scripting. This function will raise if there is an error parsing b . Examples Two timecodes running at the same rate: iex&gt; a = Timecode . with_frames! ( &quot;01:30:21:17&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; Timecode . sub ( a , b ) |&gt; Timecode . to_string ( ) &quot;&lt;00:30:21:17 @ &lt;23.98 NTSC NDF&gt;&gt;&quot; When b is greater than a , the result is negative: iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; Timecode . sub ( a , b ) |&gt; Timecode . to_string ( ) &quot;&lt;-01:00:00:00 @ &lt;23.98 NTSC NDF&gt;&gt;&quot; Two timecodes running at different rates: iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:02&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;00:00:00:02&quot; , Rates . f47_95 ( ) ) iex&gt; Timecode . sub ( a , b ) |&gt; Timecode . to_string ( ) &quot;&lt;01:00:00:01 @ &lt;23.98 NTSC NDF&gt;&gt;&quot; Using a timcode and a bare string: iex&gt; a = Timecode . with_frames! ( &quot;01:30:21:17&quot; , Rates . f23_98 ( ) ) iex&gt; Timecode . sub ( a , &quot;01:00:00:00&quot; ) |&gt; Timecode . to_string ( ) &quot;&lt;00:30:21:17 @ &lt;23.98 NTSC NDF&gt;&gt;&quot;","ref":"Vtc.Timecode.html#sub/2","title":"Vtc.Timecode.sub/2","type":"function"},{"doc":"Returns the the formatted SMPTE timecode: (ex: 01:00:00:00). Drop frame timecode will be rendered with a ';' sperator before the frames field. What it is Timecode is used as a human-readable way to represent the id of a given frame. It is formatted to give a rough sense of where to find a frame: {HOURS}:{MINUTES}:{SECONDS}:{FRAME}. For more on timecode, see Frame.io's excellent post on the subject. Where you see it Timecode is ubiquitous in video editing, a small sample of places you might see timecode: Source and Playback monitors in your favorite NLE. Burned into the footage for dailies. Cut lists like an EDL.","ref":"Vtc.Timecode.html#timecode/1","title":"Vtc.Timecode.timecode/1","type":"function"},{"doc":"","ref":"Vtc.Timecode.html#to_string/1","title":"Vtc.Timecode.to_string/1","type":"function"},{"doc":"Returns a new Timecode with a frames/1 return value equal to the frames arg. Arguments frames : A value which can be represented as a frame number / frame count. Must implement the Frames protocol. rate : Frame-per-second playback value of the timecode.","ref":"Vtc.Timecode.html#with_frames/2","title":"Vtc.Timecode.with_frames/2","type":"function"},{"doc":"As Timecode.with_frames/2 , but raises on error.","ref":"Vtc.Timecode.html#with_frames!/2","title":"Vtc.Timecode.with_frames!/2","type":"function"},{"doc":"Returns a new Timecode with a premiere_ticks/1 return value equal to the ticks arg. Arguments ticks : Any value that can represent the number of ticks for a given timecode. Must implement the PremiereTicks protocol. rate : Frame-per-second playback value of the timecode.","ref":"Vtc.Timecode.html#with_premiere_ticks/2","title":"Vtc.Timecode.with_premiere_ticks/2","type":"function"},{"doc":"As with_premiere_ticks/2 , but raises on error.","ref":"Vtc.Timecode.html#with_premiere_ticks!/2","title":"Vtc.Timecode.with_premiere_ticks!/2","type":"function"},{"doc":"Returns a new Timecode with a Timecode.seconds field value equal to the seconds arg. Arguments seconds : A value which can be represented as a number of seconds. Must implement the Seconds protocol. rate : Frame-per-second playback value of the timecode.","ref":"Vtc.Timecode.html#with_seconds/2","title":"Vtc.Timecode.with_seconds/2","type":"function"},{"doc":"As with_seconds/2 , but raises on error.","ref":"Vtc.Timecode.html#with_seconds!/2","title":"Vtc.Timecode.with_seconds!/2","type":"function"},{"doc":"Type returned by with_seconds/2 and with_frames/2 .","ref":"Vtc.Timecode.html#t:parse_result/0","title":"Vtc.Timecode.parse_result/0","type":"type"},{"doc":"Timecode type. Fields seconds : The real-world seconds elapsed since 01:00:00:00 as a rational value. (Note: The Ratio module automatically will coerce itself to an integer whenever possible, so this value may be an integer when exactly a whole-second value). rate : the Framerate of the timecode.","ref":"Vtc.Timecode.html#t:t/0","title":"Vtc.Timecode.t/0","type":"type"},{"doc":"Holds the individual sections of a timecode for formatting / manipulation.","ref":"Vtc.Timecode.Sections.html","title":"Vtc.Timecode.Sections","type":"module"},{"doc":"Holds the individual sections of a timecode for formatting / manipulation. Fields negative : Whether the timecode is less than 0. hours : Hours place value. minutes : Minutes place value. seconds : Seconds place value. frames : Frames place value.","ref":"Vtc.Timecode.Sections.html#t:t/0","title":"Vtc.Timecode.Sections.t/0","type":"type"},{"doc":"Helper functions and types for working with the Ratio module.","ref":"Vtc.Utils.Rational.html","title":"Vtc.Utils.Rational","type":"module"},{"doc":"Does the divmod operation on a rational vale, returns a {whole_dividend, rational_rainder} tuple.","ref":"Vtc.Utils.Rational.html#divmod/2","title":"Vtc.Utils.Rational.divmod/2","type":"function"},{"doc":"Rounds a Ratio to the nearest integer.","ref":"Vtc.Utils.Rational.html#round/1","title":"Vtc.Utils.Rational.round/1","type":"function"},{"doc":"The Ratio module will often convert itself to an integer value if the result would be a whole number, but otherwise return a %Ratio{} struct. This type can be used when working with such a value.","ref":"Vtc.Utils.Rational.html#t:t/0","title":"Vtc.Utils.Rational.t/0","type":"type"},{"doc":"Exception returned when a framerate cannot be parsed.","ref":"Vtc.Framerate.ParseError.html","title":"Vtc.Framerate.ParseError","type":"exception"},{"doc":"Returns a message for the error reason.","ref":"Vtc.Framerate.ParseError.html#message/1","title":"Vtc.Framerate.ParseError.message/1","type":"function"},{"doc":"Type of ParseError Fields reason : The reason the error occurred must be one of the following: :bad_drop_rate : Returned when the playback speed of a framerate with an ntsc value of :drop is not divisible by 3000/1001 (29.97), for more on why drop-frame framerates must be a multiple of 29.97, see: https://www.davidheidelberger.com/2010/06/10/drop-frame-timecode/ :invalid_ntsc : Returned when the ntsc value is not one of the allowed atom values. :unrecognized_format : Returned when a string value is not a recognized format. :imprecise - Returned when a float was passed with an NTSC value of nil. Without the ability to round to the nearest valid NTSC value, floats are not precise enough to build an arbitrary framerate.","ref":"Vtc.Framerate.ParseError.html#t:t/0","title":"Vtc.Framerate.ParseError.t/0","type":"type"},{"doc":"Exception returned when there is an error parsing a Timecode value.","ref":"Vtc.Timecode.ParseError.html","title":"Vtc.Timecode.ParseError","type":"exception"},{"doc":"Returns a message for the error reason.","ref":"Vtc.Timecode.ParseError.html#message/1","title":"Vtc.Timecode.ParseError.message/1","type":"function"},{"doc":"Type of Timecode.ParseError Fields reason : The reason the error occurred must be one of the following: :unrecognized_format : Returned when a string value is not a recognized timecode, runtime, etc. format. :bad_drop_frames : The field value cannot exist in properly formatted drop-frame timecode.","ref":"Vtc.Timecode.ParseError.html#t:t/0","title":"Vtc.Timecode.ParseError.t/0","type":"type"},{"doc":"vtc-ex A SMPTE Timecode Library for Elixir","ref":"readme.html","title":"vtc-ex","type":"extras"},{"doc":"Let's take a quick look at how we can use this library! alias Vtc.Framerate alias Vtc.Rates alias Vtc.Timecode # It&#39;s easy to make a new 23.98 NTSC timecode. We use the with_frames constructor here # since timecode is really a human-readable way to represent frame count. iex&gt; tc = Timecode . with_frames! ( &quot;17:23:13:02&quot; , Rates . f23_98 ) &lt; 17 : 23 : 00 : 02 @ &lt; 23.98 NTSC NDF &gt;&gt; # We can get all sorts of ways to represent the timecode. iex&gt; Timecode . timecode ( tc ) &quot;17:23:00:02&quot; iex&gt; Timecode . frames ( tc ) 1501922 iex&gt; tc . seconds 751711961 &lt;|&gt; 12000 iex&gt; Timecode . runtime ( tc , 3 ) &quot;17:24:15.676&quot; iex&gt; Timecode . premiere_ticks ( tc ) 15915544300656000 iex&gt; Timecode . feet_and_frames ( tc ) &quot;93889+10&quot; # We can inspect the framerate. iex&gt; tc . rate . ntsc :non_drop iex &gt; tc . rate . playback 24000 &lt;|&gt; 1001 iex&gt; Framerate . timebase ( tc . rate ) 24 # Parsing is flexible # Partial timecode: iex&gt; Timecode . with_frames! ( &quot;3:12&quot; , Rates . f23_98 ) &lt; 03 : 00 : 00 : 12 @ &lt; 23.98 NTSC NDF &gt;&gt; # Frame count: iex&gt; Timecode . with_frames! ( 24 , Rates . f23_98 ) &lt; 00 : 00 : 01 : 00 @ &lt; 23.98 NTSC NDF &gt;&gt; # Seconds: iex&gt; Timecode . with_seconds! ( 1.5 , Rates . f23_98 ) &lt; 00 : 05 : 23 : 04 @ &lt; 23.98 NTSC NDF &gt;&gt; # Runtime: iex&gt; Timecode . with_seconds! ( &quot;00:05:23.5&quot; , Rates . f23_98 ) &lt; 00 : 05 : 23 : 04 @ &lt; 23.98 NTSC NDF &gt;&gt; # Premiere Ticks: iex&gt; Timecode . with_premiere_ticks! ( 254_016_000_000 , Rates . f23_98 ) &lt; 00 : 00 : 01 : 00 @ &lt; 23.98 NTSC NDF &gt;&gt; # Feet and Frames: iex&gt; Timecode . with_frames! ( &quot;1+08&quot; , Rates . f23_98 ) &lt; 00 : 00 : 01 : 00 @ &lt; 23.98 NTSC NDF &gt;&gt; # We can add two timecodes: iex&gt; tc = Timecode . add ( tc , Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ) ) &lt; 18 : 23 : 13 : 02 @ &lt; 23.98 NTSC NDF &gt;&gt; # But if we want to do something quickly, we just use a timecode string instead. iex&gt; tc = Timecode . add ( tc , &quot;00:10:00:00&quot; ) &lt; 18 : 33 : 13 : 02 @ &lt; 23.98 NTSC NDF &gt;&gt; # Adding ints means adding frames. iex&gt; tc = Timecode . add ( tc , 38 ) &lt; 18 : 33 : 14 : 16 @ &lt; 23.98 NTSC NDF &gt;&gt; # We can subtract too. iex&gt; tc = Timecode . sub ( tc , &quot;01:00:00:00&quot; ) &lt; 17 : 33 : 14 : 16 @ &lt; 23.98 NTSC NDF &gt;&gt; # It&#39;s easy to compare two timecodes iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ) iex&gt; b = Timecode . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ) iex&gt; Timecode . compare ( a , b ) :gt # And even compare directly with a timecode string iex&gt; Timecode . compare ( a , &quot;00:59:00:00&quot; ) :lt # We can multiply iex&gt; Timecode . mult ( tc , 2 ) &lt; 35 : 06 : 29 : 08 @ &lt; 23.98 NTSC NDF &gt;&gt; # ... divide ... iex&gt; Timecode . div ( tc , 2 ) &lt; 17 : 33 : 14 : 16 @ &lt; 23.98 NTSC NDF &gt;&gt; # We can make dropframe timecode for 29.97 or 59.94 using one of the pre-set # framerates. iex&gt; drop_frame = Timecode . with_frames! ( 15000 , Rates . f29_97_Df ) &lt; 00 : 08 : 20 ; 18 @ &lt; 29.97 NTSC DF &gt;&gt; # We can make new timecodes with arbitrary framerates if we want: iex&gt; tc = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Framerate . new! ( 240 , nil ) ) &lt; 01 : 00 : 00 : 00 @ &lt; 240.0 fps &gt;&gt; # Using `:non_drop` indicates this is an NTSC timecode, and will convert whole-number # timebases to the correct speed. &gt;&gt;&gt; vtc . Timecode ( &quot;01:00:00:00&quot; , Framerate . new! ( 48 , :non_drop ) ) &lt; 01 : 00 : 00 : 00 @ &lt; 47.95 NTSC &gt;&gt; # We can also rebase the frames using a new framerate! iex&gt; tc = Timecode . rebase ( tc , Rates . f23_98 ) &lt; 02 : 00 : 00 : 00 @ &lt; 23.98 NTSC &gt;&gt;","ref":"readme.html#demo","title":"vtc-ex - Demo","type":"extras"},{"doc":"SMPTE Conventions: [X] NTSC [X] Drop-Frame [ ] Interlaced timecode Timecode Representations: [X] Timecode | '01:00:00:00' [X] Frames | 86400 [X] Seconds | 3600.0 [X] Runtime | '01:00:00.0' [X] Rational | 18018/5 [X] Feet+Frames | '5400+00' [X] 35mm, 4-perf [ ] 35mm, 3-perf [ ] 35mm, 2-perf [ ] 16mm [X] Premiere Ticks | 15240960000000 Operations: [X] Comparisons (==, &lt;, &lt;=, &gt;, &gt;=) [X] Add [X] Subtract [X] Scale (multiply and divide) [ ] Divmod [ ] Modulo [ ] Negative [ ] Absolute [X] Rebase (recalculate frame count at new framerate) Flexible Parsing: [X] Partial timecodes | '1:12' [X] Partial runtimes | '1.5' [X] Negative string values | '-1:12', '-3+00' [X] Poorly formatted tc | '1:13:4' [X] Built-in consts for common framerates. [ ] Range type for working with and comparing frame ranges.","ref":"readme.html#features","title":"vtc-ex - Features","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding vtc to your list of dependencies in mix.exs : def deps do [ { :vtc , &quot;~&gt; 0.1&quot; } ] end","ref":"readme.html#installation","title":"vtc-ex - Installation","type":"extras"},{"doc":"Timecode: A History But first: what is timecode? If you're already familiar with timecode, it's history, and it's flavors, feel free to skip this section. Back in the days of film, a running strip of numbers ran along the edge of the film stock to uniquely identify each frame, called keycode Keycode was essential to the film editing process. The raw negative of a film is irreplaceable: you loose quality each time you make a copy. Editing film is necessarily a destructive process , and often required multiple iterations. It would be just a tad nerve-wracking to take a pair of scissors and some glue to the one-of-a-kind film reels straight out of the camera on set, then running it over and over through a flatbed. To avoid potential disaster, editors made their cut of the film using copies of the raw negative, called a work print , allowing the editor to work without fear of sinking a project from slicing, dicing, and wearing at the film. When the edit was complete, it was necessary to know exactly where the edits had been made, so it could be recreated with the raw negative for finishing. A cut list would be written out, with the exact reels and keycodes for every cut, and would be used to make an exact duplicate of the editor's work print with the mint condition raw negative. In video and digital filmmaking, the same approach is used. Massive RAW files from a RED, ARRI, Sony, or other cinema camera are rendered down to more manageable files an Editor's machine won't choke on. Once the edit is complete, the raw files are re-assembled using a digital cutlist on a powerful machine for finishing out the film. In film, we referenced keycode to know exactly what frame was being displayed on screen at any given time. In digital video, we reference the timecode of a given frame. For a technical deep-dive into the many flavors of timecode, check out Frame.io's excellent blogpost on the subject.","ref":"history.html","title":"Timecode: A History","type":"extras"}]